import os
import numpy as np
import math
import sys

eleid = {'C':1, 'N':2, 'O':3, 'S':4, 'P':5, 'F':6, 'CL':7, 'BR':8, 'I':9}

rs = 0.25
thr = 50.0
lth = int(np.rint(thr/rs))

ComFile = sys.argv[1]
ProPHFile = sys.argv[2]
ComPHFile = sys.argv[3]
ProPHHydroFile = sys.argv[4]
ComPHHydroFile = sys.argv[5]
OutFile = sys.argv[6]

small = 0.0001

# Simply the count of atom pairs with a distance in each interval
# For type 3 also count distance that are smaller than right end of the interval
feature_i_0 = np.zeros([lth,36], float)
feature_i_0_2 = np.zeros([lth,36], float)
data = np.load(ComFile)
PRO = data['PRO']; LIG = data['LIG'];
for proatm in PRO:
	for ligatm in LIG:
		pt = proatm['typ'].replace(" ",""); pt = pt.upper();
		lt = ligatm['typ'].replace(" ",""); lt = lt.upper();
		pid = eleid[pt]; lid = eleid[lt];
		fid = (pid-1)*9+lid-1
		dis = np.linalg.norm(proatm['pos'][:] - ligatm['pos'][:])
		if dis > 50.0: continue
		intid = int(math.floor(dis/rs))
		feature_i_0[intid,fid] += 1.0
		feature_i_0_2[0:intid+1,fid] += 1.0
# 1. Count of birth in each interval
# 2. Count of death in each interval
# 3. Count of bars that span over each interval
# Orders: Pro Betti-1 + Pro Betti-2 + Com Betti-1 + Com Betti-2
feature_i_1_2 = np.zeros([lth,18], float)
names = [ProPHHydroFile, ComPHHydroFile]
for j in range(0,2):
	infile = open(names[j])
	lines = infile.read().splitlines()
	for line in lines:
		dim, b, d = line.split()
		dim = int(dim); b = float(b); d = float(d);
		if d - b < small or dim == 0 or b > 50.0 or d > 50.0: continue
		# Birth
		intid = int(math.floor(b/rs))
		fid = j*6+(dim-1)*3
		feature_i_1_2[intid, fid] += 1.0
		# Death
		intid = int(math.floor(d/rs))
		fid = j*6+(dim-1)*3+1
		feature_i_1_2[intid, fid] += 1.0
		# Bar Count
		bintid = int(math.floor(b/rs)); dintid = int(math.floor(d/rs));
		fid = j*6+(dim-1)*3+2
		feature_i_1_2[bintid:dintid+1, fid] += 1.0
feature_i_1_2[:,12:18] = feature_i_1_2[:,6:12] - feature_i_1_2[:,0:6]

feature_all_i_1_2 = np.zeros([lth,18], float)
names = [ProPHFile, ComPHFile]
for j in range(0,2):
	infile = open(names[j])
	lines = infile.read().splitlines()
	for line in lines:
		dim, b, d = line.split()
		dim = int(dim); b = float(b); d = float(d);
		if d - b < small or dim == 0 or b > 50.0 or d > 50.0: continue
		# Birth
		intid = int(math.floor(b/rs))
		fid = j*6+(dim-1)*3
		feature_all_i_1_2[intid, fid] += 1.0
		# Death
		intid = int(math.floor(d/rs))
		fid = j*6+(dim-1)*3+1
		feature_all_i_1_2[intid, fid] += 1.0
		# Bar Count
		bintid = int(math.floor(b/rs)); dintid = int(math.floor(d/rs));
		fid = j*6+(dim-1)*3+2
		feature_all_i_1_2[bintid:dintid+1, fid] += 1.0
feature_all_i_1_2[:,12:18] = feature_all_i_1_2[:,6:12] - feature_all_i_1_2[:,0:6]

feature = np.concatenate((feature_i_0, feature_i_1_2, feature_all_i_1_2), axis=1)
outfile = open(OutFile, 'w')
np.save(outfile, feature)
outfile.close()
