import os, sys, gudhi
import numpy as np
import scipy as sp

InputFile = sys.argv[1]
ProOutFile = sys.argv[2]
LigOutFile = sys.argv[3]
ComOutFile = sys.argv[4]

structfile = open(InputFile)
data = np.load(structfile)
PRO = data['PRO']; LIG = data['LIG']
structfile.close()
pro_pt = []; lig_pt = []; pro_lig_pt = []
for atom in PRO:
	pos = []
	pos.extend([atom['pos'][0], atom['pos'][1], atom['pos'][2]])
	pro_pt.append(pos); pro_lig_pt.append(pos)
for atom in LIG:
	pos = []
	pos.extend([atom['pos'][0], atom['pos'][1], atom['pos'][2]])
	lig_pt.append(pos); pro_lig_pt.append(pos)

#Protein
alpha_complex = gudhi.AlphaComplex(points=pro_pt)
PH = alpha_complex.create_simplex_tree().persistence()
pro_out_file = open(ProOutFile, 'w')
for simplex in PH:
    dim, b, d = int(simplex[0]), float(simplex[1][0]), float(simplex[1][1])
    if d-b < 0.1: continue
    pro_out_file.write(str(dim)+' '+str(b)+' '+str(d)+'\n')
pro_out_file.close()
#Protein&Ligand
alpha_complex = gudhi.AlphaComplex(points=pro_lig_pt)
PH = alpha_complex.create_simplex_tree().persistence()
pro_lig_out_file = open(ComOutFile, 'w')
for simplex in PH:
    dim, b, d = int(simplex[0]), float(simplex[1][0]), float(simplex[1][1])
    if d-b < 0.1: continue
    pro_lig_out_file.write(str(dim)+' '+str(b)+' '+str(d)+'\n')
pro_lig_out_file.close()
#Ligand
alpha_complex = gudhi.AlphaComplex(points=lig_pt)
PH = alpha_complex.create_simplex_tree().persistence()
lig_out_file = open(LigOutFile, 'w')
for simplex in PH:
    dim, b, d = int(simplex[0]), float(simplex[1][0]), float(simplex[1][1])
    if d-b < 0.1: continue
    lig_out_file.write(str(dim)+' '+str(b)+' '+str(d)+'\n')
lig_out_file.close()
